on:
  push:
    branches:
      - main

jobs:
  build:
    runs-on: macos-latest
    steps:
      - uses: actions/checkout@v4

      - name: Set up ruby env
        uses: ruby/setup-ruby@v1
        with:
          ruby-version: 3.2.1
          bundler-cache: true

      - name: Setup java for android build
        uses: actions/setup-java@v4
        with:
          java-version: '17'
          distribution: 'zulu'

      - name: Setup android SDK
        uses: android-actions/setup-android@v3

      - name: Infer version number from git tag
        id: version
        env: 
          REF_NAME: ${{ github.ref_name }}
        run:
          # remove the 'v' prefix from the tag name
          echo "VERSION=${REF_NAME//v}" >> $GITHUB_OUTPUT

      - name: Load secrets from github
        run: |
          echo "${{ secrets.ANDROID_SECRET_PROPERTIES }}" > secrets.properties
          echo "${{ secrets.ANDROID_KEYSTORE }}" > release.keystore
          echo "${{ secrets.ANDROID_GOOGLE_PLAY_JSON }}" > google-key.json
        working-directory: android

      - name: Install fastlane
        run: bundle install
        working-directory: android

      - name: Run fastlane lane
        run: bundle exec fastlane deploy_release
        working-directory: android
        env:
          VERSION_NAME: ${{ steps.version.VERSION }}
